#ifndef KEY_METRICS_H
#define KEY_METRICS_H 1
enum {
   user_defined,
  /*
   * These are my configuration metrics which don't change between reboots
   */
   cpu_num,
   cpu_speed,
   mem_total,
   swap_total,
   boottime,
   sys_clock,
   machine_type,
   os_name,
   os_release,
  /*
   * These are my state metrics which are always a changin' changin'
   */
   cpu_user,
   cpu_nice,
   cpu_system,
   cpu_idle,
   cpu_aidle,
   load_one,
   load_five,
   load_fifteen,
   proc_run,
   proc_total,
   mem_free,
   mem_shared,
   mem_buffers,
   mem_cached,
   swap_free,
   /* internal.. ignore */
   gexec,
   heartbeat,
   mtu,
   location,
   /*
    * added by swagner for extended solaris monitoring.
    */
#ifdef SOLARIS
   cpu_wio,
   bread_sec,
   bwrite_sec,
   lread_sec,
   lwrite_sec,
   phread_sec,
   phwrite_sec,
   rcache,
   wcache,
#endif
#ifdef LINUX
   bytes_in,
   bytes_out,
   pkts_in,
   pkts_out,
   disk_total,
   disk_free,
   part_max_used,
#endif
#ifdef HPUX
   cpu_intr,
   cpu_ssys,
   cpu_wait,
   cpu_arm,
   cpu_rm,
   cpu_avm,
   cpu_vm,
#endif
#ifdef FREEBSD
   bytes_in,
   bytes_out,
   pkts_in,
   pkts_out,
   disk_total,
   disk_free,
   part_max_used,
#endif
   num_key_metrics
}  key_metrics;
#endif
